-- removes decimals
function AGT.removeDecimal(number)
    local num = number local num2 = tostring(num) local found = nil
    for i=1,num2:len() do 
        if string.sub(num2,i,i) == "." then found = i end
    end
	if type(found) == "number" then num2 = string.sub(num2,1,found-1) end
    num = tonumber(num2)
    return num
end

-- get guild index from guild number
function AGT.getGuildID(guildNumber)
	local temp = AGT.data.guildID[guildNumber]
	return temp
end

-- get guild number from guild index
function AGT.getGuildNumber(guildIndex)
	for temp = 1, 5 do
		if(AGT.data.guildID[temp] == guildIndex) then
			return temp
		end
	end return nil
end

-- get online guildmates
function AGT.onlineMembers(Gid)
	local AGT_Online = 0
	for AGT_num = 1, GetNumGuildMembers(Gid) do
		local AGT_name,AGT_note,AGT_rank,AGT_stat,AGT_sec = GetGuildMemberInfo(Gid, AGT_num)
		if(AGT_stat ~= PLAYER_STATUS_OFFLINE)then AGT_Online = AGT_Online + 1 end
	end return AGT_Online
end

-- round numbers
function AGT.round(num, idp)
    local mult = 10^(idp or 0)
    if num >= 0 then return math.floor(num * mult + 0.5) / mult
    else return math.ceil(num * mult - 0.5) / mult end
end

--calculate time
function AGT.calculateTime(sec)
	local seconds = sec local minutes = 0 local hours = 0 local days = 0
	while (seconds >= 60) do seconds = seconds - 60 minutes = minutes + 1 end
	while (minutes >= 60) do minutes = minutes - 60 hours = hours + 1 end
	while (hours >= 24) do hours = hours - 24 days = days + 1 end
	if(days > 0)then return days.." days "..hours.." hrs "..minutes.." mins" else 
		if(hours > 0)then return hours.." hrs "..minutes.." mins" else
			if(minutes > 0)then return minutes.." mins "..seconds.." secs" else
				return seconds.." secs" end
		end
	end
end

-- fix name
function AGT.fixName(name)
	if(name:sub(1,1)~= "@") then return "@"..name
	else return name end
end

-- get member index
function AGT.getMemberIndex(Gid,name)
	local MemId = 0
	for AGT_num = 1, GetNumGuildMembers(Gid) do
		local AGT_name,AGT_note,AGT_rank,AGT_stat,AGT_sec = GetGuildMemberInfo(Gid, AGT_num)
		if(AGT_name == name) then return AGT_num end
	end return MemId
end

--build character string
function AGT.buildCharacter(alliance,cname,class,level,vetLevel,supressLvl)
	
	supressLvl = supressLvl or false
	local Ali = ""
	local Name = ""
	local Name2 = ""
	local LVL = ""
	local Css = ""
	
	-- calculate alliance
	if AGT.saved.Character.showAlliance then
		if(alliance==ALLIANCE_ALDMERI_DOMINION) then
			if AGT.saved.Character.fullAlliance then
				if AGT.saved.Character.colorAlliance then
					Ali="|r|cccff00[Aldmeri Dominion]|r^c"
				else
					Ali = "[Aldmeri Dominion]"
				end
			else
				if AGT.saved.Character.colorAlliance then
					Ali="|r|cccff00[AD]|r^c"
				else
					Ali = "[AD]"
				end
			end
		elseif(alliance==ALLIANCE_DAGGERFALL_COVENANT)then
			if AGT.saved.Character.fullAlliance then
				if AGT.saved.Character.colorAlliance then
					Ali="|r|c00bfff[Daggerfall Covenant]|r^c"
				else
					Ali = "[Daggerfall Covenant]"
				end
			else
				if AGT.saved.Character.colorAlliance then
					Ali="|r|c00bfff[DC]|r^c"
				else
					Ali = "[DC]"
				end
			end
		elseif(alliance==ALLIANCE_EBONHEART_PACT) then
			if AGT.saved.Character.fullAlliance then
				if AGT.saved.Character.colorAlliance then
					Ali="|r|cff0000[Ebonheart Pact]|r^c"
				else
					Ali = "[Ebonheart Pact]"
				end
			else
				if AGT.saved.Character.colorAlliance then
					Ali="|r|cff0000[EP]|r^c"
				else
					Ali = "[EP]"
				end
			end
		end
	end	
	
	-- calculate character name
	if AGT.saved.Character.showCharacterName then
		Name = cname:sub(1, cname:len()-3)
		Name2 = " on character "
	end
	
	--calculate level
	if AGT.saved.Character.showLevel then
		if not supressLvl then
			if(vetLevel > 0) then
				LVL = "(lvl:"..level.."-V"..vetLevel..")"
			else
				LVL = "(lvl:"..level..")"
			end
		end
	end
	
	--calculate class
	if AGT.saved.Character.showClass then
		if AGT.saved.Character.fullClass then
			if (class == 1) then Css 		= "[Dragon Knight]"
			elseif (class == 2) then Css 	= "[Sorcerer]"
			elseif (class == 3) then Css 	= "[Nightblade]"
			elseif (class == 6) then Css 	= "[Templar]" 
			end
		else
			if (class == 1) then Css 		= "[DK]"
			elseif (class == 2) then Css 	= "[S]"
			elseif (class == 3) then Css 	= "[NB]"
			elseif (class == 6) then Css 	= "[T]" 
			end
		end
	end
	
	-- return decorated character
	if AGT.saved.Character.showInfo then
		return Name2..Ali.." "..Css..Name..LVL
	else
		return ""
	end
end

--build status string
function AGT.buildStatusString(status)
	if AGT.saved.Settings.showStatusColor then
		if(status ==  PLAYER_STATUS_AWAY ) 				then return "changed status to |r|cccff00away|r^c"
		elseif(status ==  PLAYER_STATUS_DO_NOT_DISTURB) then return "changed status to |r|cff0000do not disturb|r^c"
		elseif(status == PLAYER_STATUS_OFFLINE) 		then return "is now |r|c686868offline|r^c"
		elseif(status == PLAYER_STATUS_ONLINE) 			then return "is now |r|c00ff00online|r^c"
		else return "changed status to an unknown status" end
	else
		if(status ==  PLAYER_STATUS_AWAY ) 				then return "changed status to away"
		elseif(status ==  PLAYER_STATUS_DO_NOT_DISTURB) then return "changed status to do not disturb"
		elseif(status == PLAYER_STATUS_OFFLINE) 		then return "is now offline"
		elseif(status == PLAYER_STATUS_ONLINE) 			then return "is now online"
		else return "changed status to an unknown status" end
	end
end

-- convert RGB to hex
function AGT.RGB_HEX(r,g,b,a)
	return AGT.HEX_NUM(AGT.round(r*255,0))..AGT.HEX_NUM(AGT.round(g*255,0))..AGT.HEX_NUM(AGT.round(b*255,0))
end
function AGT.HEX_NUM(dec)
	local num = tonumber(dec) local hexstr = '0123456789abcdef' local s = ''
    while num > 0 do
        local mod = math.fmod(num, 16)
        s = string.sub(hexstr, mod+1, mod+1) .. s
        num = math.floor(num / 16)
    end
    if s == '' then s = '0' end
	if s:len() == 1 then s = "0"..s end
    return s
end