AGT.lootString = ""
-- initialize events
function AGT:InitializeEvents()
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GUILD_MEMBER_PLAYER_STATUS_CHANGED			, AGT.statusChanged)	
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GUILD_MEMBER_CHARACTER_LEVEL_CHANGED 		, AGT.guildmateLeveled)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GUILD_MEMBER_CHARACTER_VETERAN_RANK_CHANGED	, AGT.guildmateLeveled)	
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_CHAT_MESSAGE_CHANNEL							, AGT.chatMessage)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GUILD_MEMBER_ADDED							, AGT.newGuildmate)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GUILD_MEMBER_REMOVED							, AGT.guildmateLeft)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GUILD_MEMBER_CHARACTER_ZONE_CHANGED			, AGT.changedZone)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GUILD_MEMBER_RANK_CHANGED					, AGT.changedRank)	
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_GAME_CAMERA_UI_MODE_CHANGED					, AGT.gameLoaded)	
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_MOUNT_UPDATE									, AGT.mountUpdated)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_SMITHING_TRAIT_RESEARCH_COMPLETED			, AGT.researchComplete)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_LOOT_RECEIVED								, AGT.lootRecieved)
	EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_LOOT_CLOSED									, AGT.lootClosed)
end

--status change
function AGT.statusChanged(eventCode, gid, AccName, oldStatus, newStatus)
	if(AccName ~= GetDisplayName())then -- if is not you
		local hasChr,cName,zName,cType,cAlli,cLVL,cVet = GetGuildMemberCharacterInfo(gid, AGT.getMemberIndex(gid,AccName))
		local tmpMsg = AccName..AGT.buildCharacter(cAlli,cName,cType,cLVL,cVet).." "..AGT.buildStatusString(newStatus).."."
		if(IsFriend(AccName))then
			if(newStatus == PLAYER_STATUS_ONLINE or newStatus == PLAYER_STATUS_OFFLINE)then				
				if not AGT:notificationSuppression(tmpMsg) then
					AGT:addNotification(AGT.note.STATUS_CHANGE,AGT.getGuildNumber(gid),tmpMsg,true)
				end
			else
				if not AGT:notificationSuppression(tmpMsg) then
					AGT:addNotification(AGT.note.STATUS_CHANGE,AGT.getGuildNumber(gid),tmpMsg)
				end
			end
		else
			if not AGT:notificationSuppression(tmpMsg) then
				AGT:addNotification(AGT.note.STATUS_CHANGE,AGT.getGuildNumber(gid),tmpMsg)
			end
		end
	end
end

--guildmate levelled
function AGT.guildmateLeveled(eventCode, gid, player, name, lvl)
	local hasChr,cName,zName,cType,cAlli,cLVL,cVet = GetGuildMemberCharacterInfo(gid, AGT.getMemberIndex(gid,player))
	if(lvl == 0) then 
		local tmpMsg = player..AGT.buildCharacter(cAlli,cName,cType,cLVL,cVet,true).." has deleted his/her character!"
		if not AGT:notificationSuppression(tmpMsg) then
			AGT:addNotification(AGT.note.LEVEL_UP,AGT.getGuildNumber(gid),tmpMsg)
		end
	else
		local tmpMsg = player..AGT.buildCharacter(cAlli,cName,cType,cLVL,cVet,true).." just levelled to level "..lvl.."!"
		if not AGT:notificationSuppression(tmpMsg) then
			AGT:addNotification(AGT.note.LEVEL_UP,AGT.getGuildNumber(gid),tmpMsg)
		end		
	end	
end

-- chat message
function AGT.chatMessage(eventCode, msgType, from, text)
	local guildChat = {[12]=1,[13]=2,[14]=3,[15]=4,[16]=5}
	local officerChat = {[17]=1,[18]=2,[19]=3,[20]=4,[21]=5}
	
	if(msgType > 11 and msgType < 17) then --guild chat	
		if(text:sub(1,2) == "<<")then -- IS AN ALERT
			AGT:addNotification(AGT.note.ALERT,guildChat[msgType],from..": "..text,true)			
		else -- guild message
			AGT:addNotification(AGT.note.GUILD,guildChat[msgType],from..": "..text,true)
		end		
	end
	
	if(msgType > 16 and msgType < 22) then --officer chat
		AGT:addNotification(AGT.note.OFFICER,officerChat[msgType],from..": "..text,true)
	end
	
	if(msgType == 2) then --whisper
		AGT:addNotification(AGT.note.WHISPER,nil,from:gsub("%^.*x$","")..": "..text,true)
	end
	
	if(msgType == 1) then --yell
		AGT:addNotification(AGT.note.YELL,nil,from:gsub("%^.*x$","")..": "..text,true)
	end
end

-- new guildmate
function AGT.newGuildmate(eventCode, gid, AccName)
	local hasChr,cName,zName,cType,cAlli,cLVL,cVet = GetGuildMemberCharacterInfo(gid, AGT.getMemberIndex(gid,AccName))
	AGT:addNotification(AGT.note.STATUS_CHANGE,AGT.getGuildNumber(gid),AccName..AGT.buildCharacter(cAlli,cName,cType,cLVL,cVet).." has joined the guild.")
end

-- guildmate left
function AGT.guildmateLeft(eventCode, gid, AccName)
	AGT:addNotification(AGT.note.STATUS_CHANGE,AGT.getGuildNumber(gid),AccName.." has left the guild.")
end

-- guildmate changed zone
function AGT.changedZone(eventCode, gid, AccName, CName, Zone)
	local MyhasChr,MycName,MyzName,MycType,MycAlli,MycLVL,MycVet = GetGuildMemberCharacterInfo(gid, AGT.getMemberIndex(gid,GetDisplayName()))
	local TheirhasChr,TheircName,TheirzName,TheircType,TheircAlli,TheircLVL,TheircVet = GetGuildMemberCharacterInfo(gid, AGT.getMemberIndex(gid,AccName))
	if(AccName ~= GetDisplayName()) then
		if(AGT.saved.Settings.sameZone == true) then
			if(Zone == MyzName) then			
				local tmpMsg = AccName..AGT.buildCharacter(TheircAlli,TheircName,TheircType,TheircLVL,TheircVet).." has entered "..Zone
				if not AGT:notificationSuppression(tmpMsg) then
					AGT:addNotification(AGT.note.CHANGE_ZONE,AGT.getGuildNumber(gid),tmpMsg)
				end	
			end		
		else
			local tmpMsg = AccName..AGT.buildCharacter(TheircAlli,TheircName,TheircType,TheircLVL,TheircVet).." has entered "..Zone
			if not AGT:notificationSuppression(tmpMsg) then
				AGT:addNotification(AGT.note.CHANGE_ZONE,AGT.getGuildNumber(gid),tmpMsg)
			end
		end
	else	
		local tmpMsg = "You have entered "..Zone
		if not AGT:notificationSuppression(tmpMsg) then
			AGT:addNotification(AGT.note.SUCCESS,nil,tmpMsg)
		end
	end
end

-- guildmate changed rank
function AGT.changedRank(eventCode, Gid, AccName, newRank)
	local AGT_Rank = ""
	if(newRank == 1) then AGT_Rank = "Guild Master" end	if(newRank == 2) then AGT_Rank = "Officer" end
	if(newRank == 3) then AGT_Rank = "Member" end		if(newRank == 4) then AGT_Rank = "Recruit" end
	if(GetGuildRankCustomName(Gid, newRank) ~= "") then AGT_Rank = GetGuildRankCustomName(Gid, newRank) end
	AGT:addNotification(AGT.note.STATUS_CHANGE,AGT.getGuildNumber(Gid),AccName.."'s rank has been changed to "..GetGuildRankCustomName(Gid, newRank))
end

-- game loaded
function AGT.gameLoaded()
	if not AGT.loaded then
		AGT.loaded = true		
		AGT.updateTime = AGT.tickCount + 3
	end	
end

-- mount updated
function AGT.mountUpdated(eventCode, Stable_Slot)
	if(IsStableSlotEmpty(Stable_Slot)==false) then
		local Feed_Hours = AGT.removeDecimal(GetTimeUntilMountCanBeFed(Stable_Slot))
		if(Feed_Hours ~= nil) then
			if(Feed_Hours > 0) then
				AGT.mount[Stable_Slot] = nil
			end
		else
			AGT.mount[Stable_Slot] = nil
		end
	end
end

-- crafting research complete
function AGT.researchComplete (eventCode, craftingSkillType, researchLineIndex, traitIndex)
end

function AGT.lootRecieved (eventCode, receivedBy, itemName, quantity, itemSound, lootType, mySelf)
	if(lootType == LOOT_TYPE_MONEY) then
		if(mySelf) then
			if(AGT.lootString == "")then
				AGT.lootString = "You picked up "..quantity.." gold"
			else
				AGT.lootString = AGT.lootString..", "..quantity.." gold"
			end
		end
	else
		if(mySelf) then
			if(AGT.lootString == "")then
				AGT.lootString = "You picked up ["..itemName.."] x "..quantity
			else
				AGT.lootString = AGT.lootString..", ["..itemName.."] x "..quantity
			end
		end
	end
end

function AGT.lootClosed(eventCode)
	if(AGT.lootString == "")then
		AGT:addNotification(AGT.note.LOOT,nil,"You picked up gold.");
	else
		AGT:addNotification(AGT.note.LOOT,nil,AGT.lootString);
	end
	AGT.lootString = ""
	
end