--## This Page Handles The Add-on's Settings

-- Load Libraries
AGT.LAM = LibStub:GetLibrary("LibAddonMenu-2.0")

-- settings main function
function AGT:buildSettings()
	AGT.next = {[0]=0,[1]=0,[2]=0,[3]=0,[4]=0,[5]=0}
	AGT.createPanel()
	AGT.loadPanelOptions()
end

function AGT.inc(value)
	AGT.next[value] = AGT.next[value] + 1
	return AGT.next[value]
end

function AGT.createPanel()
	local panelData = {
		type = "panel",
		name = AGT.name,
		displayName = "|c00ff00Amilious Guild Tools|r",
		version = AGT.version,
		author = AGT.author,
		slashCommand = "/agt",
		registerForRefresh = true,
		registerForDefaults = true,
	}
	AGT.LAM:RegisterAddonPanel(AGT.name .."Options", panelData)
end

function AGT.loadPanelOptions()
	local optionsData = {
		[AGT.inc(0)] = {
			type 	= "description",
			title 	= "About",
			text 	= AGT.description,
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."Guild Settings".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text 	= "Here you can set options for individual guilds.  Change which notifications you see, where you see them, and how you see them.",
--Guilds		
		}, [AGT.inc(0)] = {
			type	= "submenu",
			name	= "|cFF9900".."Guild-1: "..GetGuildName(1).."|r",
			tooltip	= "Guild-1's settings!",
			controls = AGT.guildSettings(1)
		}, [AGT.inc(0)] = {
			type	= "submenu",
			name	= "|cFF9900".."Guild-2: "..GetGuildName(2).."|r",
			tooltip	= "Guild-2's settings!",
			controls = AGT.guildSettings(2)
		}, [AGT.inc(0)] = {
			type	= "submenu",
			name	= "|cFF9900".."Guild-3: "..GetGuildName(3).."|r",
			tooltip	= "Guild-3's settings!",
			controls = AGT.guildSettings(3)
		}, [AGT.inc(0)] = {
			type	= "submenu",
			name	= "|cFF9900".."Guild-4: "..GetGuildName(4).."|r",
			tooltip	= "Guild-4's settings!",
			controls = AGT.guildSettings(4)
		}, [AGT.inc(0)] = {
			type	= "submenu",
			name	= "|cFF9900".."Guild-5: "..GetGuildName(5) .."|r",
			tooltip	= "Guild-5's settings!",
			controls = AGT.guildSettings(5)
-- On-Screen
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."On-Screen Display Settings".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text 	= "Here you can set options for your on screen display.",
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show On Screen Display".."|r",
			tooltip = "Turns the on-screen display on/off.",
			getFunc = function() return AGT.saved.OnScreen.isDisplayOn end,
			setFunc = function(value) AGT.saved.OnScreen.isDisplayOn = value; AmiliousGuildToolsMessage:SetHidden(not value) end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Lock Screen Display".."|r",
			tooltip = "Locks/Unlocks on-screen display.  When unlocked it allows you to move the Amilious Guild Tools GUI.",
			getFunc = function() return AGT.saved.OnScreen.isDisplayLocked end,
			setFunc = function(value) AGT.saved.OnScreen.isDisplayLocked = value; AGT:configureOnScreenDisplay() end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type	= "slider",
			name	= "|c99CCFF".."Size Of On-Screen Display".."|r",
			tooltip	= "Sets the size for the on-screen display.",
			min		= 1,
			max		= 20,
			step	= 1,
			getFunc = function() return AGT.saved.OnScreen.scale*10 end ,
			setFunc = function(value) AGT.saved.OnScreen.scale = value/10; AGT:configureOnScreenDisplay(); end,
			default = 10,
			width = "half"
		}, [AGT.inc(0)] = {
			type	= "slider",
			name	= "|c99CCFF".."Show Message For ___ seconds".."|r",
			tooltip	= "Sets the time messages are displayed for.",
			min		= 1,
			max		= 20,
			step	= 1,
			getFunc = function() return AGT.saved.OnScreen.displayTicks end ,
			setFunc = function(value) AGT.saved.OnScreen.displayTicks = value end,
			default = 3,
			width = "half"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Vertical Align".."|r",
			choices = {"Top","Center","Bottom"},
			getFunc = function() return AGT.verAlign[AGT.saved.OnScreen.vertAlign] end,
			setFunc = function(value) AGT.saved.OnScreen.vertAlign = AGT.verAlign[value]; AGT:configureOnScreenDisplay(); end,
			width = "half",
			default = "Center"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Horizontal Align".."|r",
			choices = {"Left","Center","Right"},
			getFunc = function() return AGT.horAlign[AGT.saved.OnScreen.horizAlign] end,
			setFunc = function(value) AGT.saved.OnScreen.horizAlign = AGT.horAlign[value]; AGT:configureOnScreenDisplay(); end,
			width = "half",
			default = "Center"
-- Sounds
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."Sounds".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text = "Here you can set the sounds that are heard when receiving a notification."
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Sounds".."|r",
			tooltip = "Turn sounds on/off.",
			getFunc = function() return AGT.saved.Settings.sounds end,
			setFunc = function(value) AGT.saved.Settings.sounds = value; end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Message Of The Day".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.motd end,
			setFunc = function(value) AGT.saved.Sounds.motd = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Dialog_Show"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Status Change".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.status end,
			setFunc = function(value) AGT.saved.Sounds.status = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "SkillLine_Added"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Level Up".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.level end,
			setFunc = function(value) AGT.saved.Sounds.level = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Overland_Boss_Kill"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Zone Change".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.zone end,
			setFunc = function(value) AGT.saved.Sounds.zone = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "SkillType_World"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Alert".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.alert end,
			setFunc = function(value) AGT.saved.Sounds.alert = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Book_Acquired"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Trying".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.trying end,
			setFunc = function(value) AGT.saved.Sounds.trying = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "CODEX_Close"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Error".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.error end,
			setFunc = function(value) AGT.saved.Sounds.error = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Quest_StepFailed"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Success".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.success end,
			setFunc = function(value) AGT.saved.Sounds.success = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Lockpicking_success"			
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Guild Message".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.guild end,
			setFunc = function(value) AGT.saved.Sounds.guild = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "New_Mail"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Officer Message".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.officer end,
			setFunc = function(value) AGT.saved.Sounds.officer = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Click_Negative"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Whisper".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.whisper end,
			setFunc = function(value) AGT.saved.Sounds.whisper = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Click_Positive"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Yell".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.yell end,
			setFunc = function(value) AGT.saved.Sounds.yell = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Book_Acquired"			
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Mount Hungry".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.mount end,
			setFunc = function(value) AGT.saved.Sounds.mount = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Stats_Purchase"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Hour Notification".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.hour end,
			setFunc = function(value) AGT.saved.Sounds.hour = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Quest_Accept"
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Crafting Research Available".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.craft end,
			setFunc = function(value) AGT.saved.Sounds.craft = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Quest_Abandon",
			disabled = true
		}, [AGT.inc(0)] = {
			type="dropdown",
			name="|c99CCFF".."Loot Sound".."|r",
			choices = AGT.soundNames,
			getFunc = function() return AGT.saved.Sounds.loot end,
			setFunc = function(value) AGT.saved.Sounds.loot = value; PlaySound(AGT.sound[value]) end,
			width = "half",
			default = "Lockpicking_lockpick_contact",
			disabled = false
-- General Notifications
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."General Notifications".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text = "Here you can set general notification settings."
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Whispers On Screen".."|r",
			tooltip = "Turns whispers in the on-screen display on/off.",
			getFunc = function() return AGT.saved.note.whisper end,
			setFunc = function(value) AGT.saved.note.whisper = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Yells On Screen".."|r",
			tooltip = "Turns yells in the on-screen display on/off.",
			getFunc = function() return AGT.saved.note.yell end,
			setFunc = function(value) AGT.saved.note.yell = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Loot On Screen".."|r",
			tooltip = "Turns loot notifications in the on-screen display on/off.",
			getFunc = function() return AGT.saved.note.lootScreen end,
			setFunc = function(value) AGT.saved.note.lootScreen = value end,
			width 	= "half",
			default = true	
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Loot In Chat".."|r",
			tooltip = "Turns loot notifications in the chat box on/off.",
			getFunc = function() return AGT.saved.note.lootChat end,
			setFunc = function(value) AGT.saved.note.lootChat = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "colorpicker",
			name 	= "|c99CCFF".."Loot Color".."|r",
			tooltip = "Sets the looting display color.",
			getFunc	= function() return unpack(AGT.saved.note.lootColor) end,
			setFunc = function(r,g,b,a) AGT.saved.note.lootColor = {r,g,b,a} end,
			width = "half",
			default = { r = 0.470588, g=0.470588, b=0.470588, a=1}				
-- Character Options
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."Character Options".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text = "These options change the way toons are displayed in notifications."
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Character Info".."|r",
			tooltip = "Turns character info on/off in notifications.",
			getFunc = function() return AGT.saved.Character.showInfo end,
			setFunc = function(value) AGT.saved.Character.showInfo = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Alliance".."|r",
			tooltip = "Turns alliance info on/off in notifications.",
			getFunc = function() return AGT.saved.Character.showAlliance end,
			setFunc = function(value) AGT.saved.Character.showAlliance = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Use Alliance Full Name".."|r",
			tooltip = "If on, uses full name for alliance in notifications.",
			getFunc = function() return AGT.saved.Character.fullAlliance end,
			setFunc = function(value) AGT.saved.Character.fullAlliance = value end,
			width 	= "half",
			default = false
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Alliance Color".."|r",
			tooltip = "Turns alliance colors on/off in notifications.",
			getFunc = function() return AGT.saved.Character.colorAlliance end,
			setFunc = function(value) AGT.saved.Character.colorAlliance = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Class".."|r",
			tooltip = "Turns class info on/off in notifications.",
			getFunc = function() return AGT.saved.Character.showClass end,
			setFunc = function(value) AGT.saved.Character.showClass = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Use Class Full Name".."|r",
			tooltip = "If on, uses full name for classes in notifications.",
			getFunc = function() return AGT.saved.Character.fullClass end,
			setFunc = function(value) AGT.saved.Character.fullClass = value end,
			width 	= "half",
			default = false
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Character Name".."|r",
			tooltip = "Turns character name on/off in notifications.",
			getFunc = function() return AGT.saved.Character.showCharacterName end,
			setFunc = function(value) AGT.saved.Character.showCharacterName = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Level".."|r",
			tooltip = "Turns level info on/off in notifications.",
			getFunc = function() return AGT.saved.Character.showLevel end,
			setFunc = function(value) AGT.saved.Character.showLevel = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Show Level Color".."|r",
			tooltip = "Turns level color on/off in notifications.",
			getFunc = function() return AGT.saved.Character.colorLevel end,
			setFunc = function(value) AGT.saved.Character.colorLevel = value end,
			width 	= "half",
			default = true,
			disabled = true
-- MISC Options
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."MISC Options".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text = "Here you will find various miscellaneous options."
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Only Show Zone If The Same".."|r",
			tooltip = "If off all zone changes will be displayed in notifications.  If on only same zone notifications will be seen.",
			getFunc = function() return AGT.saved.Settings.sameZone end,
			setFunc = function(value) AGT.saved.Settings.sameZone = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Tell Me When Mounts Are Hungry".."|r",
			tooltip = "When on you will recieve notifications when your mounts are hungry.",
			getFunc = function() return AGT.saved.Settings.mountHunger end,
			setFunc = function(value) AGT.saved.Settings.mountHunger = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(0)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Tell Me Played Hours".."|r",
			tooltip = "Notify me on every hour played.",
			getFunc = function() return AGT.saved.Settings.hourNotify end,
			setFunc = function(value) AGT.saved.Settings.hourNotify = value end,
			width 	= "half",
			default = true
-- Slash Commands
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."Slash Commands".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text  = "|c00ff00/g#invite  {name}|r or |c00ff00/g#add {name}|r invites {name} to guild #.\n"..
					"|c00ff00/g#count|r displays the number of members in guild #.\n"..
					"|c00ff00/g#online|r displays the number of online members in guild #.\n"..
					"|c00ff00/g#offline|r displays the number of offline members in guild #.\n"..
					"|c00ff00/g#leave|r or |c00ff00/g#quit|r leaves guild #.\n"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text  = "|c00ff00/g#kick {name}|r or |c00ff00/g#remove {name}|r kicks {name} from guild #.\n"..
					"|c00ff00/g#promote {name}|r , |c00ff00/g#up {name} , or |c00ff00/g#reankup {name}|r ranks up {name} in guild #.\n"..
					"|c00ff00/g#demote {name}|r , |c00ff00/g#down {name} , or |c00ff00/g#reankdown {name}|r ranks down {name} in guild #.\n"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text  = "|c00ff00/g#laston {name}|r or |c00ff00/g#lastonline {name}|r displays when {name} was last online.\n"..
					"|c00ff00/g#motd|r or |c00ff00/g#messageoftheday|r displays guild #'s message of the day.\n"..
					"|c00ff00/g#activity|r displays the last time everyone in guild # was online.\n"..
					"|c00ff00/g#prune|r kicks guild #'s inactive members.  Set how long inactive until kicked in guild settings.  Players whos guild note begins with 'skip', will not be kicked.\n"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text  = "\n\n"..
					"|c00ff00/mounthunger|r will display all mounts hunger, or if followed by a name it will only check that mount.\n"..
					"|c00ff00/agt|r will open Amilious Guild Tools settings."
		}, [AGT.inc(0)] = {
			type 	= "description",
			text  = ""
-- Donations
		}, [AGT.inc(0)] = {
			type 	= "header",
			name	= "|cFF0000".."Donations".."|r"
		}, [AGT.inc(0)] = {
			type 	= "description",
			text = "If you would like to help me out my making a donation search for AmiliousGuildTools, on www.esoui.com. "..
			"I would like to thank the following people for there donations:\n\n".."|cFFCC00Jonathan H.|r  |c00ff00$10|r,  |cFFCC00Brandon Q.|r  |c00ff00$5|r,  |cFFCC00Eric D.|r  |c00ff00$10|r,"..
			" |cFFCC00Sharen S.|r |c00ff00$10|r"
		}		
	}
	AGT.LAM:RegisterOptionControls(AGT.name .."Options", optionsData)
end

function AGT.guildSettings(guildNumber)
	local guildOptions = {
		[AGT.inc(guildNumber)] = {
			type	= "description",
			text	= "These are the settings for your guild guild " ..guildNumber..".  Your current guild ".. guildNumber .." is "..GetGuildName(guildNumber).."."
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Notifications".."|r",
			tooltip = "",
			getFunc = function() return AGT.saved.guild[guildNumber].showNotifications end,
			setFunc = function(value) AGT.saved.guild[guildNumber].showNotifications = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."On-Screen Display".."|r",
			tooltip = "",
			getFunc = function() return AGT.saved.guild[guildNumber].showOnScreen end,
			setFunc = function(value) AGT.saved.guild[guildNumber].showOnScreen = value end,
			width 	= "half",
			default = true		
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."In-Chat Notifications".."|r",
			tooltip = "",
			getFunc = function() return AGT.saved.guild[guildNumber].showInChat end,
			setFunc = function(value) AGT.saved.guild[guildNumber].showInChat = value end,
			width 	= "half",
			default = true		
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Notification Sounds".."|r",
			tooltip = "",
			getFunc = function() return AGT.saved.guild[guildNumber].playSounds end,
			setFunc = function(value) AGT.saved.guild[guildNumber].playSounds = value end,
			width 	= "half",
			default = true
-- Notifications			
		}, [AGT.inc(guildNumber)] = {
			type 	= "header",
			name	= "Notifications"
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."MOTD In Chat".."|r",
			tooltip = "Turn message of the day notifications on/off in the chat box.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.motd_CT end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.motd_CT = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."MOTD On-Screen".."|r",
			tooltip = "Turn message of the day notifications on/off on the on-screen display.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.motd_OS end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.motd_OS = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Level Up In Chat".."|r",
			tooltip = "Turn level up notifications on/off in the chat box.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.level_CT end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.level_CT = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Level Up On-Screen".."|r",
			tooltip = "Turn level up notifications on/off on the on-screen display.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.level_OS end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.level_OS = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Status Change In Chat".."|r",
			tooltip = "Turn status change notifications on/off in the chat box.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.status_CT end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.status_CT = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Status Change On-Screen".."|r",
			tooltip = "Turn status change notifications on/off on the on-screen display.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.status_OS end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.status_OS = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Zone Change In Chat".."|r",
			tooltip = "Turn zone change notifications on/off in the chat box.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.zone_CT end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.zone_CT = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Zone Change On-Screen".."|r",
			tooltip = "Turn zone change notifications on/off on the on-screen display.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.zone_OS end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.zone_OS = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Alert On-Screen".."|r",
			tooltip = "Turn alert notifications on/off on the on-screen display.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.alert_OS end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.alert_OS = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Guild Messages".."|r",
			tooltip = "Turn guild notifications on/off on the on-screen display.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.guild end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.guild = value end,
			width 	= "half",
			default = false
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Officer Messages".."|r",
			tooltip = "Turn officer notifications on/off on the on-screen display.",
			getFunc = function() return AGT.saved.guild[guildNumber].note.officer end,
			setFunc = function(value) AGT.saved.guild[guildNumber].note.officer = value end,
			width 	= "half",
			default = true
-- Sounds			
		}, [AGT.inc(guildNumber)] = {
			type 	= "header",
			name	= "Sounds"
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."MOTD".."|r",
			tooltip = "Turn guilds motd sounds on/off.",
			getFunc = function() return AGT.saved.guild[guildNumber].sound.motd end,
			setFunc = function(value) AGT.saved.guild[guildNumber].sound.motd = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Level Up".."|r",
			tooltip = "Turn guilds level up sounds on/off.",
			getFunc = function() return AGT.saved.guild[guildNumber].sound.level end,
			setFunc = function(value) AGT.saved.guild[guildNumber].sound.level = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Status Change".."|r",
			tooltip = "Turn guilds status change sounds on/off.",
			getFunc = function() return AGT.saved.guild[guildNumber].sound.status end,
			setFunc = function(value) AGT.saved.guild[guildNumber].sound.status = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Zone Change".."|r",
			tooltip = "Turn guilds zone change sounds on/off.",
			getFunc = function() return AGT.saved.guild[guildNumber].sound.zone end,
			setFunc = function(value) AGT.saved.guild[guildNumber].sound.zone = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Guild Messages".."|r",
			tooltip = "Turn guild message sounds on/off.",
			getFunc = function() return AGT.saved.guild[guildNumber].sound.guild end,
			setFunc = function(value) AGT.saved.guild[guildNumber].sound.guild = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Officer Messages".."|r",
			tooltip = "Turn guild officer messages sounds on/off.",
			getFunc = function() return AGT.saved.guild[guildNumber].sound.officer end,
			setFunc = function(value) AGT.saved.guild[guildNumber].sound.officer = value end,
			width 	= "half",
			default = true
		}, [AGT.inc(guildNumber)] = {
			type 	= "checkbox",
			name	= "|c99CCFF".."Alert".."|r",
			tooltip = "Turn guilds alert sounds on/off.",
			getFunc = function() return AGT.saved.guild[guildNumber].sound.alert end,
			setFunc = function(value) AGT.saved.guild[guildNumber].sound.alert = value end,
			width 	= "half",
			default = true
-- Colors			
		}, [AGT.inc(guildNumber)] = {
			type 	= "header",
			name	= "Colors"
		}, [AGT.inc(guildNumber)] = {
			type 	= "colorpicker",
			name 	= "Guild Color",
			tooltip = "Sets the guilds display color.",
			getFunc	= function() return unpack(AGT.saved.guild[guildNumber].color.default) end,
			setFunc = function(r,g,b,a) AGT.saved.guild[guildNumber].color.default = {r,g,b,a} end,
			width = "half",
			default = { r = 0, g=1, b=0, a=1}
		}, [AGT.inc(guildNumber)] = {
			type 	= "colorpicker",
			name 	= "MOTD",
			tooltip = "Sets the message of the day display color.",
			getFunc	= function() return unpack(AGT.saved.guild[guildNumber].color.motd) end,
			setFunc = function(r,g,b,a) AGT.saved.guild[guildNumber].color.motd = {r,g,b,a} end,
			width = "half",
			default = { r = 1, g=0.470588, b=0, a=1}
		}, [AGT.inc(guildNumber)] = {
			type 	= "colorpicker",
			name 	= "Level Up",
			tooltip = "Sets the guilds level up color.",
			getFunc	= function() return unpack(AGT.saved.guild[guildNumber].color.level) end,
			setFunc = function(r,g,b,a) AGT.saved.guild[guildNumber].color.level = {r,g,b,a} end,
			width = "half",
			default = { r = 0, g=1, b=0.470588, a=1}
		}, [AGT.inc(guildNumber)] = {
			type 	= "colorpicker",
			name 	= "Status Change",
			tooltip = "Sets the guilds status change color.",
			getFunc	= function() return unpack(AGT.saved.guild[guildNumber].color.status) end,
			setFunc = function(r,g,b,a) AGT.saved.guild[guildNumber].color.status = {r,g,b,a} end,
			width = "half",
			default = { r = 1, g=0, b=1, a=1}
		}, [AGT.inc(guildNumber)] = {
			type 	= "colorpicker",
			name 	= "Zone Change",
			tooltip = "Sets the guilds zone change color.",
			getFunc	= function() return unpack(AGT.saved.guild[guildNumber].color.zone) end,
			setFunc = function(r,g,b,a) AGT.saved.guild[guildNumber].color.zone = {r,g,b,a} end,
			width = "half",
			default = { r = 0, g=0.470588, b=1, a=1}
		}, [AGT.inc(guildNumber)] = {
			type 	= "colorpicker",
			name 	= "Alert",
			tooltip = "Sets the guilds alert color.",
			getFunc	= function() return unpack(AGT.saved.guild[guildNumber].color.alert) end,
			setFunc = function(r,g,b,a) AGT.saved.guild[guildNumber].color.alert = {r,g,b,a} end,
			width = "half",
			default = { r = 1, g=0, b=0, a=1}
		}, [AGT.inc(guildNumber)] = {
			type 	= "colorpicker",
			name 	= "Officer Chat",
			tooltip = "Sets the guilds officer chat color.",
			getFunc	= function() return unpack(AGT.saved.guild[guildNumber].color.officer) end,
			setFunc = function(r,g,b,a) AGT.saved.guild[guildNumber].color.officer = {r,g,b,a} end,
			width = "half",
			default = { r = 1, g=1, b=1, a=1}
-- MISC Options		
		}, [AGT.inc(guildNumber)] = {
			type 	= "header",
			name	= "Miscellaneous "
		}, [AGT.inc(guildNumber)] = {
			type	= "slider",
			name	= "|c99CCFF".."Days To Prune After".."|r",
			tooltip	= "Sets the number of days to prune after, when using the /g"..guildNumber.."prune command.",
			min		= 7,
			max		= 365,
			step	= 1,
			getFunc = function() return AGT.saved.guild[guildNumber].pruneTime end ,
			setFunc = function(value) AGT.saved.guild[guildNumber].pruneTime = value end,
			default = 30,
			width = "half"
		}
	}
	return guildOptions
end

function AGT.defaultsReset()
end