--## #################### ##--
--## Amilious Guild Tools ##--
--## by: @Amilious        ##--
--## last updated on:     ##--
--## 18JUN2014			  ##--
--## #################### ##--

AGT = {}
AGT.name 		= "AmiliousGuildTools"				AGT.version 		= "3.3.0.0"
AGT.author 		= "@Amilious"						AGT.savedVars 		= "AmiliousGuildToolsSaved"
AGT.saveVersion = "1"								AGT.isInitialized 	= false
AGT.tickCount 	= 0									AGT.proTick			= 0
AGT.loaded		= false								AGT.updateTime		= 0
AGT.mount = {}										AGT.lastHour		= 0
AGT.description = "AmiliousGuildTools is made by me @Amilious for my guild Fairy'Tail.  This add on brings the classic feel of most MMO guilds to elder scrolls online."
AGT.sound ={
	["No_Sound"] 			= SOUNDS.NO_SOUND,							["Ability_Failed"] 				= SOUNDS.ABILITY_FAILED,
	["Book_Acquired"] 		= SOUNDS.BOOK_ACQUIRED,						["Click"] 						= SOUNDS.DEFAULT_CLICK,
	["Click_Negative"] 		= SOUNDS.NEGATIVE_CLICK,					["Click_Positive"] 				= SOUNDS.POSITIVE_CLICK,
	["Codex_Close"] 		= SOUNDS.CODEX_WINDOW_CLOSE,				["Codex_Open"] 					= SOUNDS.CODEX_WINDOW_OPEN,
	["Dialog_Show"] 		= SOUNDS.DIALOG_SHOW,						["General_Alert_Error"] 		= SOUNDS.GENERAL_ALERT_ERROR,
	["New_Mail"] 			= SOUNDS.NEW_MAIL,							["Lockpicking_lockpick_contact"]= SOUNDS.LOCKPICKING_CONTACT,
	["Lockpicking_success"] = SOUNDS.LOCKPICKING_SUCCESS_CELEBRATION,	["Lockpicking_unlocked"] 		= SOUNDS.LOCKPICKING_UNLOCKED,
	["Mail_Sent"] 			= SOUNDS.MAIL_SENT,							["Note_Open"] 					= SOUNDS.NOTE_OPEN,
	["Overland_Boss_Kill"]	= SOUNDS.OVERLAND_BOSS_KILL,				["Quest_Abandon"] 				= SOUNDS.QUEST_ABANDONED,
	["Quest_Accept"] 		= SOUNDS.QUEST_ACCEPTED,					["Quest_StepFailed"] 			= SOUNDS.QUEST_STEP_FAILED,
	["SkillLine_Added"] 	= SOUNDS.SKILL_LINE_ADDED,					["Radial_Menu_Mouseover"] 		= SOUNDS.RADIAL_MENU_MOUSEOVER,
	["SkillLine_Leveled"] 	= SOUNDS.SKILL_LINE_LEVELED_UP,				["SkillType_World"] 			= SOUNDS.SKILL_TYPE_WORLD,
	["Stats_Purchase"] 		= SOUNDS.STATS_PURCHASE
}
AGT.soundNames = {
	"No_Sound", "Ability_Failed", "Book_Acquired", "Click", "Click_Negative", "Click_Positive", "Codex_Close", "Codex_Open",
	"Dialog_Show", "General_Alert_Error", "Lockpicking_lockpick_contact", "Lockpicking_success", "Lockpicking_unlocked",
	"Mail_Sent", "New_Mail", "Note_Open", "Overland_Boss_Kill", "Quest_Abandon", "Quest_Accept", "Quest_StepFailed",
	"Radial_Menu_Mouseover", "SkillLine_Added", "SkillLine_Leveled", "SkillType_World", "Stats_Purchase"	
	}
AGT.horAlign = { ["Left"] = TEXT_ALIGN_LEFT, ["Center"] = TEXT_ALIGN_CENTER, ["Right"] = TEXT_ALIGN_RIGHT, [TEXT_ALIGN_LEFT] = "Left", [TEXT_ALIGN_CENTER] = "Center", [TEXT_ALIGN_RIGHT] = "Right"}
AGT.verAlign = { ["Top"] = TEXT_ALIGN_TOP,["Center"] = TEXT_ALIGN_CENTER,["Bottom"] = TEXT_ALIGN_BOTTOM, [TEXT_ALIGN_TOP] = "Top", [TEXT_ALIGN_CENTER] = "Center", [TEXT_ALIGN_BOTTOM] = "Bottom"}
local BufferTable = {}

-- Initialize Addon
function AGT:Initialize()
	--initialize data
	AGT.data = {
		guildID = {},
		guildName = {},
		motd = {},
		guilds = 0
	}
	--load saved variables
	AGT:loadDefaults()
	AGT.saved = ZO_SavedVars:NewAccountWide(AGT.savedVars, 1, nil, AGT.defaults)
	-- initialize notification Library
	AGT:initializeNotifications()
	--check if updated
	AGT:checkIfUpdated()
	--build settings panel
	AGT:buildSettings()
	--configure On-Screen Display
	AmiliousGuildToolsMessage:SetHorizontalAlignment(AGT.saved.OnScreen.horizAlign)
	AmiliousGuildToolsMessage:SetVerticalAlignment(AGT.saved.OnScreen.vertAlign)
	AmiliousGuildTools:SetAnchor(CENTER, GuiRoot, TOPLEFT, AGT.saved.OnScreen.xOffset, AGT.saved.OnScreen.yOffset)
	AGT:configureOnScreenDisplay()
	-- GuildUI
	AGT:InitializeGuildUI()
	-- initialize events
	AGT:InitializeEvents()
	--initialize slash commands
	AGT:InitializeSlash()
	-- finish initializing
	AGT.isInitialized = true
end

-- Addon Main Loop
function AGT:MainLoop()
	if not AGT.BufferReached(AGT.name .."Buffer", 1) then return; end
	if not AGT.isInitialized then return; end
	AGT.tickCount = AGT.tickCount + 1
	AGT.proTick = AGT.proTick + 1
	AGT:handelNotifications()
	AGT:clearSuppressions()
	if (AGT.proTick == 6) then AGT.proTick = 1 end
	if(AGT.proTick == 1) then AGT:updateGuilds() end
	if(AGT.proTick == 2) then AGT:updateMOTD() end
	if(AGT.proTick == 3) then AGT:updateHour() end
	if(AGT.proTick == 4) then AGT:updateMount() end
	if(AGT.proTick == 5) then AGT:updateCraft() end
end

-- Update Hours Played
function AGT:updateHour()
	if not AGT.saved.Settings.hourNotify then return end	
	local NowTime = AGT.removeDecimal(GetGameTimeMilliseconds()/1000/60/60)
	if(NowTime > AGT.lastHour + 1)then
		AGT.lastHour = NowTime
		if(AGT.lastHour == 1) then 
			AGT:addNotification(AGT.note.HOUR_PLAYED,nil,"You have been playing for one hour.")
		else 
			AGT:addNotification(AGT.note.HOUR_PLAYED,nil,"You have been playing for ".. AGT.lastHour .." hours.") 
		end
	end	
end

-- Update Mount Hunger
function AGT:updateMount()
	if not AGT.saved.Settings.mountHunger then return end
	for Stable_Slot = 1, GetNumStableSlots()+1 do
		if(IsStableSlotEmpty(Stable_Slot)==false) then
			local Mount_Name = GetStableSlotInfo(Stable_Slot)
			local Feed_Hours = AGT.removeDecimal(GetTimeUntilMountCanBeFed(Stable_Slot))
			local Mount_Location = "" 
			if(Stable_Slot == 1)then Mount_Location = "active" else Mount_Location = "stabled" end
			if(Feed_Hours ~= nil) then
				if (Feed_Hours == 0 and AGT.mount[Stable_Slot] == nil) then
					--feed mount
					AGT.mount[Stable_Slot] = true
					AGT:addNotification(AGT.note.MOUNT,nil,"Your "..Mount_Location.." mount "..Mount_Name..", is hungry.")
				end
			end
		end
	end
end

-- Update Crafting Timers
function AGT:updateCraft()
end

-- Update Guilds
function AGT:updateGuilds()
	local currentGuilds = GetNumGuilds()
	if(AGT.data.guilds ~= currentGuilds) then
		AGT.data.guilds = currentGuilds
		AGT:buildGuilds()
		AGT:updateMOTD()
	end
end

-- Build Guilds
function AGT:buildGuilds()
	local currentGuilds = GetNumGuilds()
	local guildNumber = 0
	local guildIndex = 0
	while currentGuilds ~= guildNumber do
		local guildName = GetGuildName(guildIndex)
		if(guildName ~= "") then			
			guildNumber = guildNumber + 1
			AGT.data.guildID[guildNumber] = guildIndex
			AGT.data.guildName[guildNumber] = guildName 
		end
		guildIndex = guildIndex + 1
	end
end

-- Update Message Of The Day
function AGT:updateMOTD()
	for guildNumber = 1, AGT.data.guilds do
		local tempMOTD = GetGuildMotD(AGT.data.guildID[guildNumber])
		if(AGT.data.motd[guildNumber] ~= tempMOTD)then
			AGT.data.motd[guildNumber] = tempMOTD
			AGT:addNotification(AGT.note.MOTD,guildNumber,"MOTD: "..AGT.data.motd[guildNumber])
		end
	end
end

-- Addon Mouse Down
function AGT:MouseDown()
	if(AGT.saved.OnScreen.isDisplayLocked == false)then
		AmiliousGuildToolsBG:SetHidden(false)
	end
end

-- Addon Mouse Up
function AGT:MouseUp()
	AmiliousGuildToolsBG:SetHidden(true)
end

-- Addon Mouse Stopped
function AGT:StoppedMoving()
	local x, y = AmiliousGuildTools:GetCenter()
	AGT.saved.OnScreen.xOffset	= x
	AGT.saved.OnScreen.yOffset	= y
end

-- Configure On Screen Display
function AGT:configureOnScreenDisplay()
	AmiliousGuildTools:SetDimensions(400*AGT.saved.OnScreen.scale,250*AGT.saved.OnScreen.scale)
	AmiliousGuildToolsMessage:SetColor(unpack(AGT.saved.OnScreen.textColor))
	
	AmiliousGuildToolsMessage:SetScale(AGT.saved.OnScreen.scale)
	AmiliousGuildTools:SetScale(AGT.saved.OnScreen.scale)
	--AmiliousGuildTools:SetDimensions(400*AGT.saved.OnScreen.scale,250*AGT.saved.OnScreen.scale)		
	if(AGT.saved.OnScreen.isDisplayLocked == false)then
		AmiliousGuildToolsMessage:SetText("AmiliousGuildTools")
		AmiliousGuildTools:SetAlpha(1)
		AmiliousGuildTools:SetMovable(true)
	else
		AmiliousGuildToolsMessage:SetText("")
		AmiliousGuildTools:SetMovable(false)
		AmiliousGuildTools:SetDimensions(0,0)
	end
	
end


-- Initialization Caller
function AGT.OnAddOnLoaded(event, addonName)
  if addonName == AGT.name then
    AGT:Initialize()
  end
end

-- buffer
function AGT.BufferReached(key, buffer)
        if key == nil then return end
        if BufferTable[key] == nil then BufferTable[key] = {} end
        BufferTable[key].buffer = buffer or 3
        BufferTable[key].now = GetFrameTimeSeconds()
        if BufferTable[key].last == nil then BufferTable[key].last = BufferTable[key].now end
        BufferTable[key].diff = BufferTable[key].now - BufferTable[key].last
        BufferTable[key].eval = BufferTable[key].diff >= BufferTable[key].buffer
        if BufferTable[key].eval then BufferTable[key].last = BufferTable[key].now end
        return BufferTable[key].eval
    end
 
-- Register Main Event
EVENT_MANAGER:RegisterForEvent(AGT.name, EVENT_ADD_ON_LOADED, AGT.OnAddOnLoaded)